//
//  M A G N E T O
// ===============
// Datei         : Init.h
// Funktion      : Initialisiert die Hardware.
//


#ifndef INIT_H_
#define INIT_H_

// IRQs pro Sekunde
#define IRQS 1
#define PRESCALE 1024

#if F_CPU / PRESCALE / IRQS -1 < 1

# Warnung: Timer1 arbeitet falsch

#endif

#if F_CPU / PRESCALE / IRQS -1 > 0xffff

# Warnung: Timer1 arbeitet falsch

#endif

#if (F_CPU % (PRESCALE * IRQS)) != 0

# Warnung: Timer1 arbeitet ungenau

#endif

// Berechnungen fr die Schnittstelle
#define BAUD_0 115200UL						// Baudrate UART 0 RS485.
#define UBRR_VAL_0 ((F_CPU/(16*BAUD_0))-1)

//
// Ports fr bessere Lesbarkeit definieren
//

// PORT A
#define Taster_Joystick_SENSOR		DDA6
#define Taster_Joystick_PORTAL		DDA7

// PORT B
#define T_165_DATEN					DDB0	// 74165 Eingang fr Taster Muster.
#define T_165_CLK					DDB1	// Clock Signal fr 74165 zum Taster einlesen.
#define T_165_SHIFT					DDB2	// Shift Signal fr 74165 zum Taster einlesen.
#define Display_A0					DDB3	// Display.
#define Display_CS					DDB4	// Display - Chip Select.
#define MOSI						DDB5	// SPI (M)aster(O)ut(S)lave(I)n.
#define SCK							DDB7	// SPI Clock Signal.

// PORT D
#define RS485_RxD					DDD0	//
#define RS485_TxD					DDD1	//
#define RS485_DIR					DDD2	// Umschalten von Lesen und Schreiben auf den RS485 Baustein.
#define Encoder_Menue_Taster		DDD3	//
#define Encoder_Schritte_Taster		DDD4	//
#define Reset_Display				DDD5	// Display - Reset.
#define RCLK						DDD7	// Setzen der Ausgnge vom Schieberegister 749595.

#define RS485_schreiben			(PORTD |= (1<<RS485_DIR))
#define RS485_lesen				(PORTD &= ~(1<<RS485_DIR))

#define RCLK_HIGH				(PORTD |= (1<<RCLK))
#define RCLK_LOW				(PORTD &= ~(1<<RCLK))

void SPI_74595_schreiben(uint8_t);
void SPI_Display_schreiben(char);
void Display_Shadow_loeschen(void);
void Display_aktualisieren(void);
void Display_Bitmap(const unsigned char[]);
void Menue_Joystick_Sensor(void);

extern const unsigned char Bildschirm_02[];

#endif /* INIT_H_ */