//
//  M A G N E T O
// ===============
// Datei         : LED.c
// Funktion      : Steuerung der LEDs und der Tastenbeleuchtung.
//

#include <stdint.h>
#include <stdbool.h>
#include <avr/interrupt.h>
#include "LED.h"

uint8_t LED_blinken = 0;


ISR(TIMER1_COMPA_vect)
{
	LED_blinken ^= 1; // Alle 500ms ein Wechsel fr LED blinken.
}

void LED_Freigabe_EIN()
{
	LEDs &= ~(1 << LED_Freigabe);
	SPI_74595_schreiben(LEDs);
}

void LED_Freigabe_AUS()
{
	LEDs |= (1 << LED_Freigabe);
	SPI_74595_schreiben(LEDs);
}

void LED_Status_EIN()
{
	LEDs &= ~(1 << LED_Status);
	SPI_74595_schreiben(LEDs);
}

void LED_Status_AUS()
{
	LEDs |= (1 << LED_Status);
	SPI_74595_schreiben(LEDs);
}

void LED_T_freie_Fahrt_EIN()
{
	LEDs &= ~(1 << LED_T_freie_Fahrt);
	SPI_74595_schreiben(LEDs);
}

void LED_T_freie_Fahrt_AUS()
{
	LEDs |= (1 << LED_T_freie_Fahrt);
	SPI_74595_schreiben(LEDs);
}

void LED_T_Programmieren_EIN()
{
	LEDs &= ~(1 << LED_T_Programmieren);
	SPI_74595_schreiben(LEDs);
}

void LED_T_Programmieren_AUS()
{
	LEDs |= (1 << LED_T_Programmieren);
	SPI_74595_schreiben(LEDs);
}

void LED_T_Automatik_EIN()
{
	LEDs &= ~(1 << LED_T_Automatik);
	SPI_74595_schreiben(LEDs);
}

void LED_T_Automatik_AUS()
{
	LEDs |= (1 << LED_T_Automatik);
	SPI_74595_schreiben(LEDs);
}

void LED_T_Stoerung_EIN()
{
	LEDs &= ~(1 << LED_T_Stoerung);
	SPI_74595_schreiben(LEDs);
}

void LED_T_Stoerung_AUS()
{
	LEDs |= (1 << LED_T_Stoerung);
	SPI_74595_schreiben(LEDs);
}


void LED_T_Freigabe_Links_EIN()
{
	LEDs &= ~(1 << LED_T_Freigabe_Links);
	SPI_74595_schreiben(LEDs);
}

void LED_T_Freigabe_Links_AUS()
{
	LEDs |= (1 << LED_T_Freigabe_Links);
	SPI_74595_schreiben(LEDs);
}

void LED_T_Freigabe_Rechts_EIN()
{
	LEDs &= ~(1 << LED_T_Freigabe_Rechts);
	SPI_74595_schreiben(LEDs);
}

void LED_T_Freigabe_Rechts_AUS()
{
	LEDs |= (1 << LED_T_Freigabe_Rechts);
	SPI_74595_schreiben(LEDs);
}
