//
//  M A G N E T O
// ===============
// Datei         : Main.h
// Funktion      : Hauptprogramm
//

#define Befehl_Anzahl	14	// Die maximale Anzahl an Befehlen, die der Joystick versteht.
#define Befehl_Laenge	20	// Die maximale Lnge eines Befehles.

#define Daten_Anzahl	10	// Die maximale Anzahl an Daten, die einem Befehl zugeordnet werden knnen.
#define Daten_Laenge	15	// Die maximale Lnge fr Befehl-Parameter.

void Ports_INIT(void);
void LEDs_INIT(void);
void RS232_0_INIT(void);
void SPI_MasterInit(void);
void Display_INIT(void);
void Joystick_INIT(void);
void Encoder_INIT(void);
void Timer_LED_INIT(void);

void RS485_auf_Senden_schalten(void);
void RS485_auf_Empfang_schalten(void);

int uart0_putc(unsigned char);
void uart0_puts (char*);

void RS485_Adresse_festlegen(void);

void Encoder_Schritte_auswerten(void);
void Encoder_Menu_abfragen(void);
void Encoder_Schritte_abfragen(void);

void SPI_74595_schreiben(uint8_t);

void Display_aktualisieren(void);
void Display_Zeichen_Pixel(uint8_t, uint8_t, char, uint8_t);

void Joystick_Portal_abfragen(void);
void Joystick_Sensor_abfragen(void);


void LED_Freigabe_EIN();
void LED_Freigabe_AUS();
void LED_Status_EIN();
void LED_Status_AUS();
void LED_T_freie_Fahrt_EIN();
void LED_T_freie_Fahrt_AUS();
void LED_T_Programmieren_EIN();
void LED_T_Programmieren_AUS();
void LED_T_Automatik_EIN();
void LED_T_Automatik_AUS();
void LED_T_Stoerung_EIN();
void LED_T_Stoerung_AUS();
void LED_T_Freigabe_Links_EIN();
void LED_T_Freigabe_Links_AUS();
void LED_T_Freigabe_Rechts_EIN();
void LED_T_Freigabe_Rechts_AUS();

void Tasten_auswerten();

void Nachricht_Auswertung();
void Befehl_ausfuehren();

char Nachricht_Rueckmeldung[255];
unsigned char Tasten_einlesen(void);

extern bool Taste_freie_Fahrt;
extern bool Taste_Programmieren;
extern bool Taste_Automatik;
extern bool Taste_Stoerung;
extern bool Taste_Freigabe_Links;
extern bool Taste_Freigabe_Rechts;

char Tasten_Code;
char Tasten_Code_ASCII[9];
char Tasten_Code_ASCII_ALT[9];

extern uint8_t RS485_Empfang_komplett;
extern bool Nachricht_vorhanden;
extern bool Nachricht_OK;

extern char Nachricht_Befehl[Befehl_Laenge];
extern char Nachricht_Daten[Daten_Laenge];
extern char *Nachricht_Endzeichen;
extern char Nachricht_Empfaenger[3];

extern char *Nachricht_Startzeichen;
extern char Nachricht_Sender[3];

extern char RS485_Empfang_Buffer[255];

extern uint8_t LED_blinken; 
