///
//  M A G N E T O
// ===============
// Datei         : RS485.h
// Funktion      : Senden und Empfangen ber die Schnittstelle,
//				   Protokoll auswerten.
//

#ifndef RS485_H_
#define RS485_H_

#define RS485_DIR			DDD2

#define RS485_schreiben		(PORTD |= (1<<RS485_DIR))
#define RS485_lesen			(PORTD &= ~(1<<RS485_DIR))

#define Befehl_Anzahl		14	// Die maximale Anzahl an Befehlen, die der Motor versteht.
#define Befehl_Laenge		20	// Die maximale Lnge eines Befehles.

#define Daten_Anzahl		10	// Die maximale Anzahl an Daten, die einem Befehl zugeordnet werden knnen.
#define Daten_Laenge		15	// Die maximale Lnge fr Befehl-Parameter.

#define DEBUG_MODUS			0	// Wenn der DEBUG_MODUS auf 1 ist, dann werden bei der Protokoll Analyse alle
								// Einzelheiten auf die Schnittstelle ausgegeben. Das funktioniert dann nur
								// in einem Terminal. Benutze dafr HTERM unter Linux.

void LED_Status_EIN();
void LED_Status_AUS();
void RS485_auf_Empfang_schalten(void);
void RS485_auf_Senden_schalten(void);
void uart0_puts (char *s);
int uart0_putc(unsigned char c);

#endif /* RS485_H_ */