//
//  M A G N E T O
// ===============
// Datei         : SPI.c
// Funktion      : ber den SPI Bus das Display und die LEDs ansprechen.
//

#include <avr/io.h>
#include <stdint.h>
#include <util/delay.h>
#include "SPI.h"


void SPI_Display_schreiben(char SPI_Daten)
{
	PORTB &= ~(1 << Display_CS);	// Display ansprechen.
	
	SPDR = SPI_Daten;				// Starte bertragung.
	while(!(SPSR & (1<<SPIF))) ;	// Warte bis bertragung fertig ist.
	
	PORTB |= (1 << Display_CS);		// Display wieder vom Bus nehmen.
}

void SPI_74595_schreiben(uint8_t LEDs)
{
	SPDR = LEDs;					// Starte bertragung.
		
	while(!(SPSR & (1<<SPIF))) ;	// Warte bis bertragung fertig ist.

	RCLK_HIGH;						// Daten auf den Ausgang bernehmen
	RCLK_LOW;
}