//
//  M A G N E T O
// ===============
// Datei         : Tasten.c
// Funktion      : Tastenabfragen und verwalten.
//				   Hardwaremig ber 74165.
//

#include <avr/io.h>
#include <stdbool.h>
#include <util/delay.h>
#include "Tasten.h"

bool Taste_freie_Fahrt;
bool Taste_Programmieren;
bool Taste_Automatik;
bool Taste_Stoerung;
bool Taste_Freigabe_Links;
bool Taste_Freigabe_Rechts;


unsigned char Tasten_einlesen( void )
{
	// 74165
	
	unsigned char Ergebnis = 0;

	// Clock auf 1 halten

	T_CLOCK_HIGH;
	
	// ein 0/1 Puls auf der PL Leitung. Der 165 bernimmt die
	// externen Datenleitungen ins SR

	T_SHIFT_LOW;				// Ein 0/1 Impuls auf der PL Leitung bernimmt der 74165
	T_SHIFT_HIGH;				// die externen Datenleitungen ins SR.
			
	for( unsigned char j = 0; j < 8; ++j ) // Alle 8 Bits abholen
	{
		Ergebnis <<= 1;

		if( PINB & ( 1 << T_165_DATEN ) )

		Ergebnis |= 0x01;

		T_CLOCK_LOW;			// Das nchstes Bit aus dem SR mit einem 0/1 Puls raustakten
		T_CLOCK_HIGH;
	}

	return Ergebnis;
}

void Tasten_auswerten()
{
	if (!(Tasten_Code & 0b00001000)) // 0xF7
	{
		Taste_freie_Fahrt = true;
		LED_T_freie_Fahrt_EIN();
	}
	else
	{
		Taste_freie_Fahrt = false;
		LED_T_freie_Fahrt_AUS();
	}
	
	if (!(Tasten_Code & 0b00000100)) // 0xFB
	{
		Taste_Programmieren = true;
		LED_T_Programmieren_EIN();
	}
	else
	{
		Taste_Programmieren = false;
		LED_T_Programmieren_AUS();
	}
	
	if (!(Tasten_Code & 0b00000010)) // 0xFD)
	{
		Taste_Automatik = true;
		LED_T_Automatik_EIN();
	}
	else
	{
		Taste_Automatik = false;
		LED_T_Automatik_AUS();
	}
	
	if (Tasten_Code == 0xFE) Taste_Stoerung = true;
	if (Tasten_Code == 0xDF) Taste_Freigabe_Links = true;
	if (Tasten_Code == 0xEF) Taste_Freigabe_Rechts = true;
  }